program freq_based;
{$APPTYPE CONSOLE}
uses SysUtils,delp_mem;

const lambda = 1.96;
      rmax=30000;
      max_nu=2147483647 div 2; {upper limit for nu in computations}
      max_numb_blks=100; {upper limit for the number of blocks}
      blk_size=1000; {number of values stored in one block}
      eps05=0.001; {used in Fibonacci method}
      eps=1e-5; {Used to compare fitness values}

type  buf=array [0..blk_size-1] of extended;
      pbuf=^buf;
      many_buf=array[0..max_numb_blks] of pbuf;
      FreqArray=array[0..rmax] of integer;
      {array of quantities of l.o. seen i times, i=1,...,r_max}
      FlagArray=array[1..rmax] of boolean;

var
    fileerror:boolean;
    NOverflows,NErrors:integer;
    DirInfo: TSearchRec; FindStatus:integer;
    st,fn,fn_o:string; ff,fo:text; ch,last_c:char;
    stat:array[1..rmax] of longint;
    arf_ml, {maximum likelyhood for v based on Arfwedson model}
    Arf_left,Arf_right,{Boundaries of Arfwedson confidence interval}
    total,was,t,i,j,r,r1,r2,r3,k,k1,k2,k3,k_new,v,l,new:longint; a_new:boolean;
    p1,p2,p3,p,q:extended; c:char;
    tmax_last,tmax,n_series1,n_series,n,nu:longint; overflow,error:boolean;
    stir_bufs:many_buf;
    bs,v1,v2:longint; freq:FreqArray; f_i,sfstLB,first_ser:longint;
    seed:double;

FUNCTION unif(VAR seed: double) :double;
VAR temp : double;
BEGIN temp:=(25173*seed+13849)/65536;
      seed:=65536*(temp-trunc(temp));
      if seed<0 then seed:=seed+65535;
      unif:=seed/65535;
END;

PROCEDURE inran(VAR k :integer; VAR seed: double; n :integer);
VAR r : double;
BEGIN repeat r:=unif(seed);
	k:=trunc(r*n)+1
      until (k>0) and (k<n+1);
END;


FUNCTION extpower(x:extended;n :longint) : extended;
VAR i: longint; m:extended;
BEGIN m:=1;
      for i:=1 to n do m:=x*m;
      extpower:=m;
END;


function like(k,r:longint;n:extended):extended;
{computes ln(p(t|v))-ln(S(r,t))}
var s:extended; i,v:longint;
begin
  s:=0;v:=round(n);
  for i:=v-k+1 to v do s:=s+ln(i);
  s:=s-r*ln(v);
  like:=s;
end;

function f(k,r:longint; x:extended):extended;
begin
  f:=1-like(k,r,x);
{  if abs(x-k)<0.5 then f:=max_ext
{  else
  begin
    if k<=30 then  f:=1-like(k,r,x)
    else
      f:=SQR(r*ln(1-1/x)-ln(1-k/x));
  end;}
end;


function FibonacStir(k,r:longint;a,eps:extended):extended;
{Returns the argument yielding the minimum of f to the RIGHT from a,
 using the left bound proposed by Darroch for the "Stirling" likelihood.
 Border is the largest acceptable
 interval length while searching for the initial interval.
 K is the parameter needed ONLY inside the goal function}
 var f_y,f_z,dk,dk1,y,z,lambda,stop,x,Fn,Fn_1,b,f_end,
     h,f_a,f_b,prev,f_prev,old,f_old:extended; {n,k:integer;}

     tt,fftt,tt_prev,ff_prev:extended;

  function ff(tt:extended):extended;
  begin
    ff:=(1-exp(-tt))/tt;
  end;

  function bisearch(a,b,ffa,ffb:extended):extended;
  {Finds the maximal (+-eps) c in [a,b] for which ff(c)=(1-exp(-c))/c>=k/r.
   Here should be Fa>=Fc>=Fb.}
    var kr,c,ffc:extended;
  begin
{    Pa:=distr(a,k); Pb:=distr(b,k);}
    kr:=k/r;
    if (ffa<k/r) or (ffb>kr) then
    begin
      exit;
    end;

    while abs(a-b)>eps do
    begin
      c:=a+(b-a)/2;

      ffc:=ff(c);

      if ffc<kr then
        begin b:=c; ffb:=ffc; end;
      if ffc>=kr then
        begin a:=c; ffa:=ffc; end;
    end;
    bisearch:=b;
  end;

begin
  f_a:=f(k,r,a);

  tt:=0; fftt:=1;
  repeat
    tt_prev:=tt;
    ff_prev:=fftt;

{writeln('k=',k,'Pk=',p_prev);}
    tt:=tt*2;
    if tt=0 then tt:=eps;
    fftt:=ff(tt);
  until (fftt<k/r);

  if tt>eps then
    tt:=bisearch(tt_prev,tt,ff_prev,fftt)
  else tt:=r/max_nu;

  b:=r/tt;
  f_b:=f(k,r,b);

  {Fibonacci search in [a,b]}
  fn:=1;fn_1:=1; stop:=(b-a)/(2*eps);
  {n:=1;}
  while fn<=stop do
  begin
    x:=fn+fn_1;
    fn_1:=fn; fn:=x;
   {inc(n);}
  end;

{Step 1 }
  lambda:=Fn_1/Fn;

  dk:=(b-a)*lambda; dk1:=b-a-dk;
  y:=a+dk1; z:=b-dk1;
  f_y:=f(k,r,y); f_z:=f(k,r,z);
 { k:=1;}
  repeat
{    inc(k);}
  {Step 2 }
    if f_y<=f_z then
    begin
      b:=z; f_b:=f_z;
      z:=y; f_z:=f_y;
      y:=a+(dk-dk1); f_y:=f(k,r,y);
{writeln(y,' ',f_y);}
    end
    else
    begin
      a:=y; f_a:=f_y;
      y:=z; f_y:=f_z;
      z:=b-(dk-dk1); f_z:=f(k,r,z);
{writeln(z,' ',f_z, ' ',dk);}
    end;
  {Step 3}
    if dk<eps*2 then
    begin
      fibonacStir:=(y+z)/2;
{writeln(n,' ',k);}
      exit;
    end;

  {k=k+1}
    x:=dk;
    dk:=dk1;
    dk1:=x-dk;
  until false;

end;


function max_like(k,r:longint; var overflow:boolean):longint;
var ml:extended;
begin
  if k=1 then
  begin
    max_like:=1;
    exit;
  end;
  ml:=FibonacStir(k,r,k,eps05*0.8);
  if ml>=max_nu-3 then
  begin
    overflow:=true;
    exit;
  end;
  max_like:=round(ml);
end;



function like1rp(t:longint;v:extended):extended;
{computes ln(p(t|v))}
var s:extended; i:longint;
begin
  s:=0;
  for i:=1 to t-2 do s:=s+ln(v-i);
  s:=s+ln(t-1)-(t-1)*ln(v);
  like1rp:=s;
end;

function f1rp(t:longint; x:extended):extended;
begin
  f1rp:=1-like1rp(t,x);
end;

function FibonacR(t:longint;a,h,eps,border:extended):extended;
{Returns the argument yielding the minimum of f to the RIGHT from a.
 The interval of optimization is found automatically with starting
 point a and initial step h. Border is the largest acceptable
 interval length while searching for the initial interval.
 t is the parameter needed ONLY inside the goal function}
 var f_y,f_z,dk,dk1,y,z,lambda,stop,x,Fn,Fn_1,b,f_end,
     f_a,f_b,prev,f_prev,old,f_old:extended; {n,k:integer;}
begin
  f_a:=f1rp(t,a);

  repeat {finding the direction of descent}
    f_end:=f1rp(t,a+h);
    h:=h/2;
  until (f_end<f_a) or (abs(h)<eps/2);

  if abs(h)<eps/2 then
  begin
    fibonacR:=a+h;
    exit;
  end;

  h:=h*2;

  f_prev:=f_a; prev:=a;

  repeat
    old:=prev; f_old:=f_prev;
    prev:=a+h;
    f_prev:=f_end;
    h:=h*2;
    f_end:=f1rp(t,a+h);
{writeln(a+h,' ',f_end);}
  until (f_end>=f_prev) or (abs(h)>=border);

  if h<0 then
  begin
    b:=old; f_b:=f_old;
    a:=a+h; f_a:=f_end;
  end
  else
  begin
    b:=a+h; f_b:=f_end;
    a:=old; f_a:=f_old;
  end;

  {Fibonacci search in [a,b]}
  fn:=1;fn_1:=1; stop:=(b-a)/(2*eps);
  {n:=1;}
  while fn<=stop do
  begin
    x:=fn+fn_1;
    fn_1:=fn; fn:=x;
   {inc(n);}
  end;

{Step 1 }
  lambda:=Fn_1/Fn;

  dk:=(b-a)*lambda; dk1:=b-a-dk;
  y:=a+dk1; z:=b-dk1;
  f_y:=f1rp(t,y); f_z:=f1rp(t,z);
 { k:=1;}
  repeat
{    inc(k);}
  {Step 2 }
    if f_y<=f_z then
    begin
      b:=z; f_b:=f_z;
      z:=y; f_z:=f_y;
      y:=a+(dk-dk1); f_y:=f1rp(t,y);
{writeln(y,' ',f_y);}
    end
    else
    begin
      a:=y; f_a:=f_y;
      y:=z; f_y:=f_z;
      z:=b-(dk-dk1); f_z:=f1rp(t,z);
{writeln(z,' ',f_z, ' ',dk);}
    end;
  {Step 3}
    if dk<eps*2 then
    begin
      fibonacR:=(y+z)/2;
{writeln(n,' ',k);}
      exit;
    end;

  {k=k+1}
    x:=dk;
    dk:=dk1;
    dk1:=x-dk;
  until false;

end;


function max_like1rp(k:longint; var overflow:boolean):longint;
var ml:extended;
begin
  if k=1 then {impossible situation}
  begin
    max_like1rp:=0;
    exit;
  end;
  ml:=FibonacR(k,k,k,eps05*0.8,max_nu);
  if ml>=max_nu-3 then
  begin
    overflow:=true;
    exit;
  end;
  max_like1rp:=round(ml);
end;




function build_arr(r,k,v:longint):longint;
{Builds the probability array}
var tstart,start,j,r1,t,tt,t1,t_1,extra:longint; st,mul:extended;
    current_buf:pbuf;
begin
{  for j:=1 to r-k do seed:=seed/v;
  borrow:=0;}

{  lseed:=-j*lv;}

  extra:=0; {how many times extra devisions by e are done}

  for t1:=0 to k div blk_size do
    for t:=0 to blk_size-1 do stir_bufs[t1]^[t]:=0;

  stir_bufs[0]^[0]:=1;

{  writeln('BUILDING THE INTERMIDIATE PROBABILITY ARRAY (r=',r,'; tmax=',k,')');}
  for r1:=1 to r do
  begin
{    if (r1*80) div r =r1*80/r then write('*');}
    start:=k; tstart:=-333;
    if r1<k then start:=r1;
    for tt:=start div blk_size downto 0 do
    begin
      current_buf:=stir_bufs[tt];
      if tstart=-333 then tstart:=start mod blk_size else tstart:=blk_size-1;
      for t:=tstart downto 0 do
      begin
        if t>0 then
        begin
          t1:=tt*blk_size+t;
          st:=(t1*current_buf^[t]+(v-t1+1)*current_buf^[t-1])/v;
        end
        else
          if tt>0 then
          begin
            t1:=tt*blk_size;
            st:=(t1*current_buf^[0]+(v-t1+1)*stir_bufs[tt-1]^[blk_size-1])/v;
          end
          else st:=0;

        current_buf^[t]:=st;
      end;
    end;
  end;
{  writeln;}
  build_arr:=extra;
end;


function pow(x:extended;k:word):extended;
var j:longint;y:extended;
begin
   y:=1;
   if k>0 then
     for j:=1 to k do y:=y*x;
   pow:=y;
end;

function fact(x:integer):longint;
var i,j:longint;y:extended;
begin
  j:=1;
  for i:=1 to x do j:=j*i;
  fact:=j;
end;

function distr(v,k,r:longint):extended;
{computes the distribution function Fi_(k,r,v) for the distribution
with density p(t,r,v)=v!*S(r,t)/((v-t)!v^r),
using recurrent formulas for Stirling numbers and
stores some previousely found numbers in memory.}
var st,seed,sign,a,res,ss,pi,mul:extended; ln10,lv,lseed,lss,lpi:extended;
    t,s,j,t1,r1,left,extra:longint;
begin
  if k>=r then
  begin
    distr:=1;
    exit;
  end;
  res:=0;
  extra:=build_arr(r,k,v);

{  writeln('c');           }
  for t:=1 to k do
  begin
{    writeln('stir_buf^[',t,']=',stir_buf^[t]);}
     res:=res+stir_bufs[t div blk_size]^[t mod blk_size];
{    writeln('res=',res);}
  end;
{  writeln('o');}

  distr:=res;
end;



function distr1rp(nu,k,tmax:longint):extended;
{computes the distribution function Fnu(k) for the distribution
with density p(t)=1-pow(C_nu^tmax * tmax! /nu^tmax, k).}
var s,lnnu:extended; i:longint;
begin
  if nu<=tmax then
  begin
    distr1rp:=1;
    exit;
  end;
  lnnu:=ln(nu);
  s:=0;
  for i:=0 to tmax-1 do
    s:=s+ln(nu-i)-lnnu;
  distr1rp:=extpower(1-exp(s),k);
end;


function boot(var freq:FreqArray; k,r,v,m:longint; var overflow:boolean):real;
{v is max_like(k,r).
 m is the number of bootstrap samples to make.
The output is an estimate of v, corrected by bootstrap
estimation of the bias.}
var s,rnd:integer;v1,i,j,jj,jjj,count:longint; rul:FreqArray;
    cache:FreqArray;
    visited:FlagArray;
    bias:real;
begin
  j:=1;
  for i:=1 to r do cache[i]:=0;
  for i:=1 to r do
  begin
    for jj:=1 to freq[i] do
    begin
      rul[j]:=i;
      inc(j);
    end;
  end;

  if j-1<>k then
  begin
    error:=true;
    exit;
  end;

  bias:=0;
  for j:=1 to m do
  begin

    for jj:=1 to k do visited[jj]:=false;

    count:=0;
    for jjj:=1 to r do
    begin
      inran(rnd,seed,r);
      i:=1;  s:=rul[1];
      while rnd>s do
      begin
        inc(i);
        s:=s+rul[i];
      end;
      if not(visited[i]) then inc(count);
      visited[i]:=true;
    end;

    v1:=cache[count];
    if v1=0 then
    begin
      v1:=max_like(count,r,overflow);
      if overflow or error then exit;
      cache[count]:=v1;
    end;

    {v1:=count;}

    bias:=bias+(v1-v)/m;
  end;

  boot:=v-bias;

end;








begin {MAIN}
 if paramcount>0 then fn_o:=paramstr(1)
 else
 begin
    writeln('By default the name of output table is table.txt');
    fn_o:='table.txt';
 end;

{
  if fileexists(fn_o) then
  begin
    write('The file ',fn_o,' already exsts. Overwrite (Y/N)?');
    repeat
      readln(c);c:=upcase(c);
      c:=upcase(c);
    until c in ['Y','N'];
    if c='N' then halt;
  end;
 }

 assign(fo,fn_o);
 rewrite(fo);
 writeln(fo,'FileName; Restarts ;  Different ;  Plug_in;  Bootstrap; Schnabel_ML');

 NOverflows:=0; NErrors:=0;

 FindStatus:=FindFirst('*.frq',faAnyFile, DirInfo);
 while FindStatus=0 do
 begin
  writeln;
  writeln('****************************');
  writeln('Reading file:', DirInfo.Name);
  writeln('****************************');

  fn:=DirInfo.Name;
  assign(ff,fn);
  reset(ff);

  fileerror:=false;

  {$I-}
  readln(ff,r);
  {$I+}
  if IOResult<>0 then
  begin
   writeln('The first line of an input file should contain the number of restarts.');
   fileerror:=true;
   r:=0;
  end;

   if r>rmax then
   begin
    writeln('The total number of restarts exceeds the limit = ',rmax);
    fileerror:=true;
   end
   else
     for i:=0 to r do freq[i]:=0;

   k:=0;
   r1:=r;
   while (r1>0) and not(fileerror) do
   begin
    if not(fileerror) then
    begin
   {$I-}
     read(ff,j);
   {$I+}
     if IOResult<>0 then
      fileerror:=true;

     if not(fileerror) then
     begin
   {$I-}
      readln(ff,freq[j]);
   {$I+}
     end;
     if IOResult<>0 then
      fileerror:=true;
    end;

    if not(fileerror) then
    begin
     r1:=r1-j*freq[j];
     k:=k+freq[j];
    end;
   end;

  if fileerror then
  begin
   writeln('The data in file ',DirInfo.Name,' do not follow the input format (see file manual.txt).');
   writeln('File ',DirInfo.Name,' will not be processed.');
   writeln('Press Enter to continue.');
   readln;
  end;

  if not(fileerror) then
  begin

   r1:=(r div 2);
   r2:=r-r1;


   writeln('The total tumber of different l.o. visited (k):',k);


   overflow:=false;
   error:=false;

   arf_ml:=max_like(k,r,overflow);

   if overflow then arf_ml:=-1;
   if error then arf_ml:=-2;
   if overflow then
   begin
    writeln('OVERFLOW !!!');
    inc(NOverflows);
   end;
   if error then
   begin
    writeln('ERROR in computing Schnabel census max. likelihood!!!');
    writeln('Press Enter to proceed');
    readln;
    inc(NErrors);
   end;

{  writeln('k=',k);}
   writeln('Schnabel census max. likelihood:',arf_ml);

   bs:=-1;
   if not(overflow) and not(error) then
   begin
    write('Bootstrapping...');

    overflow:=false;
    error:=false;

    bs:=round(boot(freq,k,r,Arf_ML,1000,overflow));

    if overflow then
    begin
      writeln('OVERFLOW !!!');
      inc(NOverflows);
      bs:=-1;
    end;
    if error then
    begin
      writeln('ERROR in Bootstrap!!!');
      writeln('Press Enter to proceed');
      readln;
      inc(NErrors);
      bs:=-2;
      error:=false;
    end;
    writeln(' Bootstrap estimate: ', bs);
   end;


   overflow:=false;
   error:=false;

   j:=2;
   while (freq[j]=0) and (j<=r) do inc(j);
   if j=r+1 then v:=max_like1rp(freq[1]+1,overflow)
   else v:=max_like(freq[1]+freq[j],freq[1]+j*freq[j],overflow);
   if overflow then
   begin
    writeln('OVERFLOW !!!');
    inc(NOverflows);
    v:=-1;
   end;

{  writeln('1 ',v);}

   for i:=j+1 to r do
   begin
    if (freq[i]>0) and (v>=0) then v:=v+max_like(freq[i],i*freq[i],overflow);
{    if freq[i]>0 then writeln(i,' ',v);}
    if overflow then
    begin
      writeln('OVERFLOW !!!');
      v:=-1;
      inc(NOverflows);
    end;
    if error then
    begin
      writeln('ERROR !!!');
      v:=-2;
    end;
   end;
   if error then
   begin
    writeln('ERROR in computing Plug-in heuristic max. likelihood!!!');
    writeln('Press Enter to proceed');
    readln;
    inc(NErrors);
    error:=false;
   end;
   writeln('Plug-in heuristic max. likelihood:',v);

   writeln(fo, fn,'  ;  ', r,' ; ', k,'  ;  ', v , '  ;  ',bs,'  ;  ', Arf_ML);

  end; {endif}

  FindStatus:=FindNext(DirInfo);

 end; {endwhile}

 FindClose(DirInfo);


 close(fo);

 writeln('All files are processed with ',NOverflows,' overflows and ',NErrors,' errors.');

 writeln('Press Enter.');
 readln;

end.

